from sys import argv

from main_app import DiskmodGUIApplication


def get_cmd_params():
   d = {((k:=a.split("="))[0]):(k[1] if len(k) == 2 else True) for a in argv[1:]}
   o = d.get("-options")
   p = d.get("-protocol")
   h = d.get("-help", False)
   if h: print("\n\nDISKMODtools command line arguments:\n\n-options=Option file name (If not set, then 'options_default.yaml' is used.)\n-protocol=Protocol file name, which is executed after program starting.\n-help\n\n")
   return o, p, h


def main():
   options, start_protocol, h = get_cmd_params()
   if options is None and start_protocol is None and h: return
   app = DiskmodGUIApplication("options_default.yaml" if options is None else options)
   app.initialize_start_state(start_protocol)
   app.mainloop()
   

main()
