import tkinter as tk

from workflow_GUI import theme
from workflow_GUI.messagebox import msg_error, msg_yesno

from .data_select import DataSelectionDialog

class DataByFormulaDialog(DataSelectionDialog):
   
   def __init__(self, master, title):
      super().__init__(master, title, allow_no_selection=True, selectmode="multiple")
      
      F = self.frame


      l =theme.Label(F, text="New quantity name:")
      l.grid(row=0, column=0, sticky="W", padx=15, pady=(20,0))
      self.new_name = tk.StringVar(self)
      self.e_name = theme.Entry(F, textvariable=self.new_name, width=20)
      self.e_name.grid(row=1, column=0, sticky="W", padx=15, pady=(5,0))

      l =theme.Label(F, text="Formula:")
      l.grid(row=2, column=0, sticky="W", padx=15, pady=(30,0))
      self.t_formula = theme.Text(F, width=25, height=8)
      self.t_formula.grid(row=3, column=0, sticky="W", padx=15, pady=(5,0))

      l =theme.Label(F, text="Variables allowed in formula:\ndata, Tx, Ty, Tz, TdepthTOP, TdepthDEM")
      l.grid(row=4, column=0, sticky="W", padx=15, pady=(10,0))

      
      # *************** initialize ***********************

      self.set_geometry()

      self.e_name.focus()



   def set_out_params(self):
      s = self.new_name.get().strip()
      if len(s) == 0:
         msg_error(self, "No new quantity name was set.")
         self.e_name.focus()
         return
      self.out_new_name = s
      s = self.t_formula.get("0.0", "end").replace("\n"," ").strip()
      if len(s) == 0:
         msg_error(self, "No formula was set.")
         self.e_name.focus()
         return
      self.out_formula = s
      if len(self.out_selected_refs) == 0:
         if "data" in self.out_formula:
            msg_error(self, "Variable 'data' can not be used with no data selection.")
            self.t_formula.focus()
            return
      else:
         if len({r[1] for r in self.out_selected_refs}) > 1:
            msg_error(self, "Selected data can contain only one quantity.")
            self.data_lb.focus()
            return         
         if "data" not in self.out_formula:
            msg_error(self, "Variable 'data' must be contained in formula when element data are selected.")
            self.t_formula.focus()
            return     
      return True







