import tkinter as tk

from workflow_GUI import theme
from workflow_GUI.messagebox import msg_error

from .data_select import DataSelectionDialog

class DataVectorstoScalarsDialog(DataSelectionDialog):
   
   def __init__(self, master, title):
      super().__init__(master, title, selectmode="multiple")
      
      F = self.frame
      
      self.part_x = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Part x", variable=self.part_x)
      ch.grid(row=1, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.part_y = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Part Y", variable=self.part_y)
      ch.grid(row=2, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.part_z = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Part Z", variable=self.part_z)
      ch.grid(row=3, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.vsize = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Size", variable=self.vsize)
      ch.grid(row=4, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.vert_angle = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Angle relative to XY plane (degrees)", variable=self.vert_angle)
      ch.grid(row=5, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.horiz_angle = tk.BooleanVar(self, value=True)
      ch = theme.Checkbutton(F, text="Angle in XY plane (degrees)", variable=self.horiz_angle)
      ch.grid(row=6, column=0, sticky="W", padx=(10,10), pady=(15,0))

      self.set_geometry()



   def set_out_params(self):
      self.out_part_x = self.part_x.get()
      self.out_part_y = self.part_y.get()
      self.out_part_z = self.part_z.get()
      self.out_vsize = self.vsize.get()
      self.out_vert_angle = self.vert_angle.get()
      self.out_horiz_angle = self.horiz_angle.get()
      return True



