import tkinter as tk

from .entity_select import EntitySelectionDialog
from workflow_GUI import theme
from workflow_GUI.messagebox import msg_error

class MergeEntitiesDialog(EntitySelectionDialog):

   def __init__(self, master, title):
      super().__init__(master, title)
      
      l = theme.Label(self.frame, text="ID of new entity:")
      l.grid(row=0, column=0, sticky="W", padx=10, pady=(20,10))
      self.entity_id = tk.StringVar(self)
      self.e_id = theme.Entry(self.frame, textvariable=self.entity_id, width=8)
      self.e_id.grid(row=1, column=0, sticky="W", padx=10)

      l = theme.Label(self.frame, text="Name of new entity:")
      l.grid(row=2, column=0, sticky="W", padx=10, pady=(20,10))
      self.entity_name = tk.StringVar(self)
      self.e_name = theme.Entry(self.frame, textvariable=self.entity_name, width=20)
      self.e_name.grid(row=3, column=0, sticky="W", padx=10)
      
      # **************** initialize *******************
      
      self.set_geometry()



   def set_out_params(self):
      if len(self.get_sel_dims()) > 1:
         msg_error(self, "The entities are not the same dimension.")
         return False
      try: self.out_id = int(self.entity_id.get())
      except: valid = False
      else: valid = self.out_id > -1
      if not valid:
         msg_error(self, "ID must be valid integer value greater or equal to zero.")
         self.e_id.focus()
         return False
      if self.out_id in self.get_non_sel_ids():
         msg_error(self, "Entity id can not be same as the one of unselected entities.")
         self.e_id.focus()
         return False
      self.out_name = self.entity_name.get().strip()
      if self.out_name == "":
         msg_error(self, "Entity name is empty")
         self.e_name.focus()
         return False
      if self.out_name in self.get_non_sel_names():
         msg_error(self, "Entity name can not be same as the one of unselected entities.")
         self.e_name.focus()
         return False
      return True
   




