import tkinter as tk
from tkinter import filedialog

from workflow_GUI import theme
from workflow_GUI.dlg_wait_for_actions import WaitForActionsButton

class SaveMeshDialog(theme.Toplevel):

   def __init__(self, master, title):
      super().__init__(master)
      self.grab_set()
      self.title(title)

      l = theme.Label(self, text="File name:")
      l.grid(row=0, column=0, sticky="W", padx=20, pady=20)
      self.mesh_file = tk.StringVar(self)
      ef = theme.Entry(self, width=50, textvariable=self.mesh_file)
      ef.grid(row=0, column=1, columnspan=2, sticky="W", pady=20)
      b = theme.Button(self, text="...", width=4, command=self.on_save_mesh)
      b.grid(row=0, column=3, sticky="W", padx=(4,20))
      
      self.wfa_button = WaitForActionsButton(self)
      self.wfa_button.grid(row=2, column=0, sticky="W", padx=20, pady=20)
      b = theme.Button(self, text="OK", width=8, command=self.on_ok)
      b.grid(column=1, row=2, sticky="E", padx=(120,0), pady=20)
      b = theme.Button(self, text="Cancel", width=8, command=self.on_cancel)
      b.grid(column=2, row=2, sticky="E", padx=(0,0), pady=20)

      # *********** events **************************
      self.bind("<Escape>", self.on_cancel)
      self.bind("<Return>", self.on_ok)

      # ************ initialize ********************

      self.set_geometry()

      ef.focus()
      self.btn_OK = False

    
   def show_save_dialog(self):
    file_name = filedialog.asksaveasfilename(
        title="Save Mesh File",
        filetypes=[("gmsh file", ".msh")],
        defaultextension=".msh",
        initialdir=".")
    return file_name


   def on_save_mesh(self):
      if (s:=self.show_save_dialog()) is None: return
      self.mesh_file.set(s)


   def on_ok(self, event=None):
      self.out_mesh_file = self.mesh_file.get()
      self.out_wfa_ids = self.wfa_button.selected_actions_ids
      self.btn_OK = True
      self.destroy()

   def on_cancel(self, event=None):
      self.destroy()


   # ************* executing ******************

   def execute_modal(self):
      self.wait_window()
      return self.btn_OK


