
from workflow_GUI import theme
from workflow_GUI.messagebox import msg_error

from .data_select import DataSelectionDialog

class ShowDataDialog(DataSelectionDialog):
   
   def __init__(self, master, title):
      super().__init__(master, title, selectmode="browse", close_button=True)
      F = self.frame
     
      self.labs = []
      for i in range(5):
         n = theme.Label(F, width=25, anchor="w", justify="left")
         n.grid(row=i, column=0, sticky="W", padx=(0,10), pady=(15,0))
         self.labs.append(n)
   
      b = theme.Button(F, text="Write to protocol", command=self.on_write_to_protocol)
      b.grid(row=10, column=0, pady=(20,20))

      self.bind("<<ListboxSelect>>", self.on_lb_browse)
      
      # ************* initialize **************

      self.set_geometry()


      
   def set_inputs(self, data_refs_info):
      super().set_inputs(data_refs_info, [])
      self.data_refs_info = data_refs_info
      self.data_lb.selection_set(0)
      self.on_lb_browse()

   
   def on_lb_browse(self, event=None):
      d = self.data_refs_info[self.get_selected_data_refs()[0]]
      p = []
      p.append("Minimum: {:g}".format(d.min))
      p.append("Maximum: {:g}".format(d.max))
      p.append("Mean: {:g}".format(d.mean))
      p.append("Median: {:g}".format(d.median))      
      if d.no_value_count > 0:
         p.append("Warning: \nNo value of {:n} elements".format(d.no_value_count))      
      else: p.append("")
      for i, s in enumerate(p): self.labs[i]["text"] = s
      
   def do_after_sorting(self):
      self.on_lb_browse()


   def on_write_to_protocol(self):
      r = self.get_selected_data_refs()
      d = self.data_refs_info[r[0]]
      t = self.title()
      self.master.protocol_perform_action(
         None, action_name=t, wait_for_actions_ids=self.wfa_button.selected_actions_ids,        
         inputs=self.master.get_protocol_e_data_refs(r),
         results=d.protocol
      )
                                          


      


      



