from . import theme

class LogFileDialog(theme.Toplevel):

   def __init__(self, master):
      super().__init__(master)
      self.grab_set()
      self.title("Log file")
      w, h = 800, 500
      self.geometry("{:n}x{:n}+{:n}+{:n}".format(w, h, master.winfo_x()+master.winfo_width()//2-w//2, master.winfo_y()+master.winfo_height()//2-h//2))
      self.minsize(w, h)
      
      self.columnconfigure(0, weight=1)
      self.rowconfigure(0, weight=1)

      t = self.text = theme.ScrolledText(self, wrap="none")
      t.grid(row=0, column=0, sticky="WENS", padx=15, pady=15)

      f = theme.Frame(self)
      f.grid(row=0, column=1, sticky="NS")
      
      b_ok = theme.Button(f, text="OK", width=8, command=self.on_ok)
      b_ok.grid(column=0, row=0, padx=15, pady=20)
      b = theme.Button(f, text="Cancel", width=8, command=self.on_cancel)
      b.grid(column=0, row=1, padx=15, pady=10)

      # *********** events **************************
      self.bind("<Escape>", self.on_cancel)

      self.text.focus()
      self.btn_OK = False


   def on_ok(self, event=None):
      self.out_wfa_ids = self.wfa_button.selected_actions_ids
      self.btn_OK = True
      self.destroy()

   def on_cancel(self, event=None):
      self.destroy()


   # ************* executing ******************

   def execute_modal(self):
      self.wait_window()
      return self.btn_OK
